
; PicBasic Pro Compiler 2.44, (c) 1998, 2003 microEngineering Labs, Inc. All Rights Reserved. 
PM_USED			EQU	1

	INCLUDE	"16F628A.INC"


; Define statements.
#define		LCD_DREG		 PORTB                   
#define		LCD_DBIT		 4                       
#define		LCD_RSREG		 PORTA                  
#define		LCD_RSBIT		 1                      
#define		LCD_EREG		 PORTA                   
#define		LCD_EBIT		 0                       
#define		LCD_BITS		 4                       
#define		LCD_LINES		 2                      
#define		BUTTON_PAUSE		 50                  

RAM_START       		EQU	00020h
RAM_END         		EQU	0014Fh
RAM_BANKS       		EQU	00003h
BANK0_START     		EQU	00020h
BANK0_END       		EQU	0007Fh
BANK1_START     		EQU	000A0h
BANK1_END       		EQU	000EFh
BANK2_START     		EQU	00120h
BANK2_END       		EQU	0014Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0217Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
T1              		EQU	RAM_START + 012h
FLAGS           		EQU	RAM_START + 014h
GOP             		EQU	RAM_START + 015h
RM1             		EQU	RAM_START + 016h
RM2             		EQU	RAM_START + 017h
RR1             		EQU	RAM_START + 018h
RR2             		EQU	RAM_START + 019h
_servo1_puls     		EQU	RAM_START + 01Ah
_servo2_puls     		EQU	RAM_START + 01Ch
_W0              		EQU	RAM_START + 01Eh
_W1              		EQU	RAM_START + 020h
_W10             		EQU	RAM_START + 022h
_W11             		EQU	RAM_START + 024h
_W12             		EQU	RAM_START + 026h
_W2              		EQU	RAM_START + 028h
_W3              		EQU	RAM_START + 02Ah
_W4              		EQU	RAM_START + 02Ch
_W5              		EQU	RAM_START + 02Eh
_W6              		EQU	RAM_START + 030h
_W7              		EQU	RAM_START + 032h
_W8              		EQU	RAM_START + 034h
_W9              		EQU	RAM_START + 036h
_K1              		EQU	RAM_START + 038h
_K2              		EQU	RAM_START + 039h
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTA
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISA
_INS             		EQU	_PORTL
_OUTS            		EQU	_PORTL
_INL             		EQU	_PORTL
_INH             		EQU	_PORTH
_OUTL            		EQU	_PORTL
_OUTH            		EQU	_PORTH
_B0              		EQU	_W0
_B1              		EQU	_W0 + 001h
_B2              		EQU	_W1
_B3              		EQU	_W1 + 001h
_B4              		EQU	_W2
_B5              		EQU	_W2 + 001h
_B6              		EQU	_W3
_B7              		EQU	_W3 + 001h
_B8              		EQU	_W4
_B9              		EQU	_W4 + 001h
_B10             		EQU	_W5
_B11             		EQU	_W5 + 001h
_B12             		EQU	_W6
_B13             		EQU	_W6 + 001h
_B14             		EQU	_W7
_B15             		EQU	_W7 + 001h
_B16             		EQU	_W8
_B17             		EQU	_W8 + 001h
_B18             		EQU	_W9
_B19             		EQU	_W9 + 001h
_B20             		EQU	_W10
_B21             		EQU	_W10 + 001h
_B22             		EQU	_W11
_B23             		EQU	_W11 + 001h
_B24             		EQU	_W12
_B25             		EQU	_W12 + 001h
_W0_LOWBYTE      		EQU	_W0
_W0_HIGHBYTE     		EQU	_W0 + 001h
_W1_LOWBYTE      		EQU	_W1
_W1_HIGHBYTE     		EQU	_W1 + 001h
_W2_LOWBYTE      		EQU	_W2
_W2_HIGHBYTE     		EQU	_W2 + 001h
_W3_LOWBYTE      		EQU	_W3
_W3_HIGHBYTE     		EQU	_W3 + 001h
_W4_LOWBYTE      		EQU	_W4
_W4_HIGHBYTE     		EQU	_W4 + 001h
_W5_LOWBYTE      		EQU	_W5
_W5_HIGHBYTE     		EQU	_W5 + 001h
_W6_LOWBYTE      		EQU	_W6
_W6_HIGHBYTE     		EQU	_W6 + 001h
_W7_LOWBYTE      		EQU	_W7
_W7_HIGHBYTE     		EQU	_W7 + 001h
_W8_LOWBYTE      		EQU	_W8
_W8_HIGHBYTE     		EQU	_W8 + 001h
_W9_LOWBYTE      		EQU	_W9
_W9_HIGHBYTE     		EQU	_W9 + 001h
_W10_LOWBYTE     		EQU	_W10
_W10_HIGHBYTE    		EQU	_W10 + 001h
_W11_LOWBYTE     		EQU	_W11
_W11_HIGHBYTE    		EQU	_W11 + 001h
_W12_LOWBYTE     		EQU	_W12
_W12_HIGHBYTE    		EQU	_W12 + 001h
#define _IN0             	_INL_0
#define _IN1             	_INL_1
#define _IN2             	_INL_2
#define _IN3             	_INL_3
#define _IN4             	_INL_4
#define _IN5             	_INL_5
#define _IN6             	_INL_6
#define _IN7             	_INL_7
#define _IN8             	_INH_0
#define _IN9             	_INH_1
#define _IN10            	_INH_2
#define _IN11            	_INH_3
#define _IN12            	_INH_4
#define _IN13            	_INH_5
#define _IN14            	_INH_6
#define _IN15            	_INH_7
#define _OUT0            	_OUTL_0
#define _OUT1            	_OUTL_1
#define _OUT2            	_OUTL_2
#define _OUT3            	_OUTL_3
#define _OUT4            	_OUTL_4
#define _OUT5            	_OUTL_5
#define _OUT6            	_OUTL_6
#define _OUT7            	_OUTL_7
#define _OUT8            	_OUTH_0
#define _OUT9            	_OUTH_1
#define _OUT10           	_OUTH_2
#define _OUT11           	_OUTH_3
#define _OUT12           	_OUTH_4
#define _OUT13           	_OUTH_5
#define _OUT14           	_OUTH_6
#define _OUT15           	_OUTH_7
#define _BIT0            	_B0_0
#define _BIT1            	_B0_1
#define _BIT2            	_B0_2
#define _BIT3            	_B0_3
#define _BIT4            	_B0_4
#define _BIT5            	_B0_5
#define _BIT6            	_B0_6
#define _BIT7            	_B0_7
#define _BIT8            	_B1_0
#define _BIT9            	_B1_1
#define _BIT10           	_B1_2
#define _BIT11           	_B1_3
#define _BIT12           	_B1_4
#define _BIT13           	_B1_5
#define _BIT14           	_B1_6
#define _BIT15           	_B1_7
#define _minusS1         	_PORTB_2
#define _plusS1          	_PORTB_3
#define _SERVO1          	_PORTA_2
#define _minusS2         	_PORTB_0
#define _plusS2          	_PORTB_1
#define _SERVO2          	_PORTA_3
#define _MENU            	_PORTA_4
#define _INL_0           	_INL, 000h
#define _INL_1           	_INL, 001h
#define _INL_2           	_INL, 002h
#define _INL_3           	_INL, 003h
#define _INL_4           	_INL, 004h
#define _INL_5           	_INL, 005h
#define _INL_6           	_INL, 006h
#define _INL_7           	_INL, 007h
#define _INH_0           	_INH, 000h
#define _INH_1           	_INH, 001h
#define _INH_2           	_INH, 002h
#define _INH_3           	_INH, 003h
#define _INH_4           	_INH, 004h
#define _INH_5           	_INH, 005h
#define _INH_6           	_INH, 006h
#define _INH_7           	_INH, 007h
#define _OUTL_0          	_OUTL, 000h
#define _OUTL_1          	_OUTL, 001h
#define _OUTL_2          	_OUTL, 002h
#define _OUTL_3          	_OUTL, 003h
#define _OUTL_4          	_OUTL, 004h
#define _OUTL_5          	_OUTL, 005h
#define _OUTL_6          	_OUTL, 006h
#define _OUTL_7          	_OUTL, 007h
#define _OUTH_0          	_OUTH, 000h
#define _OUTH_1          	_OUTH, 001h
#define _OUTH_2          	_OUTH, 002h
#define _OUTH_3          	_OUTH, 003h
#define _OUTH_4          	_OUTH, 004h
#define _OUTH_5          	_OUTH, 005h
#define _OUTH_6          	_OUTH, 006h
#define _OUTH_7          	_OUTH, 007h
#define _B0_0            	_B0, 000h
#define _B0_1            	_B0, 001h
#define _B0_2            	_B0, 002h
#define _B0_3            	_B0, 003h
#define _B0_4            	_B0, 004h
#define _B0_5            	_B0, 005h
#define _B0_6            	_B0, 006h
#define _B0_7            	_B0, 007h
#define _B1_0            	_B1, 000h
#define _B1_1            	_B1, 001h
#define _B1_2            	_B1, 002h
#define _B1_3            	_B1, 003h
#define _B1_4            	_B1, 004h
#define _B1_5            	_B1, 005h
#define _B1_6            	_B1, 006h
#define _B1_7            	_B1, 007h
#define _PORTA_0         	 PORTA, 000h
#define _PORTA_1         	 PORTA, 001h
#define _PORTA_2         	 PORTA, 002h
#define _PORTA_3         	 PORTA, 003h
#define _PORTA_4         	 PORTA, 004h
#define _PORTB_0         	 PORTB, 000h
#define _PORTB_1         	 PORTB, 001h
#define _PORTB_2         	 PORTB, 002h
#define _PORTB_3         	 PORTB, 003h
#define _PORTB_4         	 PORTB, 004h
#define _PORTB_5         	 PORTB, 005h
#define _PORTB_6         	 PORTB, 006h
#define _PORTB_7         	 PORTB, 007h

; Constants.
_T2400           		EQU	00000h
_T1200           		EQU	00001h
_T9600           		EQU	00002h
_T300            		EQU	00003h
_N2400           		EQU	00004h
_N1200           		EQU	00005h
_N9600           		EQU	00006h
_N300            		EQU	00007h
_OT2400          		EQU	00008h
_OT1200          		EQU	00009h
_OT9600          		EQU	0000Ah
_OT300           		EQU	0000Bh
_ON2400          		EQU	0000Ch
_ON1200          		EQU	0000Dh
_ON9600          		EQU	0000Eh
_ON300           		EQU	0000Fh
_MSBPRE          		EQU	00000h
_LSBPRE          		EQU	00001h
_MSBPOST         		EQU	00002h
_LSBPOST         		EQU	00003h
_LSBFIRST        		EQU	00000h
_MSBFIRST        		EQU	00001h
_CLS             		EQU	00000h
_HOME            		EQU	00001h
_BELL            		EQU	00007h
_BKSP            		EQU	00008h
_TAB             		EQU	00009h
_CR              		EQU	0000Dh
_UnitOn          		EQU	00012h
_UnitOff         		EQU	0001Ah
_UnitsOff        		EQU	0001Ch
_LightsOn        		EQU	00014h
_LightsOff       		EQU	00010h
_Dim             		EQU	0001Eh
_Bright          		EQU	00016h
	INCLUDE	"TESTER~1.MAC"
	INCLUDE	"PBPPIC14.LIB"


	ASM?
 DEVICE XT_OSC,WDT_ON,PWRT_ON,PROTECT_OFF

	ENDASM?

	OUTPUT?T	_PORTA_0
	OUTPUT?T	_PORTA_1
	OUTPUT?T	_PORTA_2
	OUTPUT?T	_PORTA_3
	INPUT?T	_PORTA_4
	INPUT?T	_PORTB_0
	INPUT?T	_PORTB_1
	INPUT?T	_PORTB_2
	INPUT?T	_PORTB_3
	OUTPUT?T	_PORTB_4
	OUTPUT?T	_PORTB_5
	OUTPUT?T	_PORTB_6
	OUTPUT?T	_PORTB_7
	MOVE?CB	007h, CMCON

	LABEL?L	_start	
	READ?CW	000h, _servo1_puls
	READ?CW	005h, _servo2_puls
	READ?CB	002h, _K1
	READ?CB	007h, _K2
	MUL?WCW	_servo1_puls, 00Ah, _servo1_puls
	MUL?WCW	_servo2_puls, 00Ah, _servo2_puls
	PAUSE?C	064h

	LABEL?L	_pulsi	
	GOSUB?L	_tipke
	HIGH?T	_SERVO1
	PAUSEUS?W	_servo1_puls
	LOW?T	_SERVO1
	HIGH?T	_SERVO2
	PAUSEUS?W	_servo2_puls
	LOW?T	_SERVO2
	GOTO?L	_pulsi

	LABEL?L	_tipke	
	CMPNE?TCL	_minusS1, 000h, L00001
	SUB?WBW	_servo1_puls, _K1, _servo1_puls
	LABEL?L	L00001	
	CMPNE?TCL	_plusS1, 000h, L00003
	ADD?WBW	_servo1_puls, _K1, _servo1_puls
	LABEL?L	L00003	
	CMPNE?TCL	_minusS2, 000h, L00005
	SUB?WBW	_servo2_puls, _K2, _servo2_puls
	LABEL?L	L00005	
	CMPNE?TCL	_plusS2, 000h, L00007
	ADD?WBW	_servo2_puls, _K2, _servo2_puls
	LABEL?L	L00007	
	PAUSE?C	00Ah
	CMPGE?WCL	_servo1_puls, 00384h, L00009
	MOVE?CW	00384h, _servo1_puls
	LABEL?L	L00009	
	CMPGE?WCL	_servo2_puls, 00384h, L00011
	MOVE?CW	00384h, _servo2_puls
	LABEL?L	L00011	
	CMPLE?WCL	_servo1_puls, 00834h, L00013
	MOVE?CW	00834h, _servo1_puls
	LABEL?L	L00013	
	CMPLE?WCL	_servo2_puls, 00834h, L00015
	MOVE?CW	00834h, _servo2_puls
	LABEL?L	L00015	
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	053h
	LCDOUT?C	031h
	LCDOUT?C	02Dh
	LCDOUT?C	03Eh
	LCDOUTCOUNT?C	004h
	LCDOUTNUM?W	_servo1_puls
	LCDOUTDEC?	
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	053h
	LCDOUT?C	032h
	LCDOUT?C	02Dh
	LCDOUT?C	03Eh
	LCDOUTCOUNT?C	004h
	LCDOUTNUM?W	_servo2_puls
	LCDOUTDEC?	
	CMPNE?TCL	_MENU, 000h, L00017
	GOTO?L	_shrani
	LABEL?L	L00017	
	RETURN?	

	LABEL?L	_shrani	
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	053h
	LCDOUT?C	068h
	LCDOUT?C	072h
	LCDOUT?C	061h
	LCDOUT?C	06Eh
	LCDOUT?C	069h
	LCDOUT?C	06Dh
	LCDOUT?C	03Fh
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	02Bh
	LCDOUT?C	044h
	LCDOUT?C	061h
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	02Dh
	LCDOUT?C	04Eh
	LCDOUT?C	065h
	CMPNE?TCL	_minusS1, 000h, L00019
	GOTO?L	_korak
	LABEL?L	L00019	
	CMPNE?TCL	_plusS1, 000h, L00021
	GOTO?L	_shrani1
	LABEL?L	L00021	
	CMPNE?TCL	_minusS2, 000h, L00023
	GOTO?L	_korak
	LABEL?L	L00023	
	CMPNE?TCL	_plusS2, 000h, L00025
	GOTO?L	_shrani1
	LABEL?L	L00025	
	PAUSE?C	001F4h
	GOTO?L	_shrani

	LABEL?L	_shrani1	
	DIV?WCW	_servo1_puls, 00Ah, T1
	WRITE?CW	000h, T1
	DIV?WCW	_servo2_puls, 00Ah, T1
	WRITE?CW	005h, T1
	PAUSE?C	064h
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	053h
	LCDOUT?C	048h
	LCDOUT?C	052h
	LCDOUT?C	041h
	LCDOUT?C	04Eh
	LCDOUT?C	049h
	LCDOUT?C	04Ch
	LCDOUT?C	021h
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	053h
	LCDOUT?C	031h
	LCDOUT?C	020h
	LCDOUT?C	069h
	LCDOUT?C	06Eh
	LCDOUT?C	020h
	LCDOUT?C	053h
	LCDOUT?C	032h
	PAUSE?C	007D0h
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	050h
	LCDOUT?C	06Fh
	LCDOUT?C	06Eh
	LCDOUT?C	06Fh
	LCDOUT?C	076h
	LCDOUT?C	06Eh
	LCDOUT?C	069h
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	07Ah
	LCDOUT?C	061h
	LCDOUT?C	067h
	LCDOUT?C	06Fh
	LCDOUT?C	06Eh
	LCDOUT?C	020h
	LCDOUT?C	021h
	PAUSE?C	003E8h
	GOTO?L	_start

	LABEL?L	_korak	
	CMPNE?TCL	_minusS1, 000h, L00027
	SUB?BCB	_K1, 001h, _K1
	LABEL?L	L00027	
	CMPNE?TCL	_plusS1, 000h, L00029
	ADD?BCB	_K1, 001h, _K1
	LABEL?L	L00029	
	CMPNE?TCL	_minusS2, 000h, L00031
	SUB?BCB	_K2, 001h, _K2
	LABEL?L	L00031	
	CMPNE?TCL	_plusS2, 000h, L00033
	ADD?BCB	_K2, 001h, _K2
	LABEL?L	L00033	
	PAUSE?C	0012Ch
	CMPGE?BCL	_K1, 001h, L00035
	MOVE?CB	001h, _K1
	LABEL?L	L00035	
	CMPGE?BCL	_K2, 001h, L00037
	MOVE?CB	001h, _K2
	LABEL?L	L00037	
	CMPLE?BCL	_K1, 0C8h, L00039
	MOVE?CB	0C8h, _K1
	LABEL?L	L00039	
	CMPLE?BCL	_K2, 0C8h, L00041
	MOVE?CB	0C8h, _K2
	LABEL?L	L00041	
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	04Bh
	LCDOUT?C	031h
	LCDOUT?C	02Dh
	LCDOUT?C	03Eh
	LCDOUTCOUNT?C	003h
	LCDOUTNUM?B	_K1
	LCDOUTDEC?	
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	04Bh
	LCDOUT?C	032h
	LCDOUT?C	02Dh
	LCDOUT?C	03Eh
	LCDOUTCOUNT?C	003h
	LCDOUTNUM?B	_K2
	LCDOUTDEC?	
	CMPNE?TCL	_MENU, 000h, L00043
	GOTO?L	_korak_shrani
	LABEL?L	L00043	
	GOTO?L	_korak

	LABEL?L	_korak_shrani	
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	053h
	LCDOUT?C	068h
	LCDOUT?C	072h
	LCDOUT?C	061h
	LCDOUT?C	06Eh
	LCDOUT?C	069h
	LCDOUT?C	06Dh
	LCDOUT?C	03Fh
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	02Bh
	LCDOUT?C	044h
	LCDOUT?C	061h
	LCDOUT?C	020h
	LCDOUT?C	020h
	LCDOUT?C	02Dh
	LCDOUT?C	04Eh
	LCDOUT?C	065h
	CMPNE?TCL	_minusS1, 000h, L00045
	GOTO?L	_korak
	LABEL?L	L00045	
	CMPNE?TCL	_plusS1, 000h, L00047
	GOTO?L	_korak_shrani1
	LABEL?L	L00047	
	CMPNE?TCL	_minusS2, 000h, L00049
	GOTO?L	_korak
	LABEL?L	L00049	
	CMPNE?TCL	_plusS2, 000h, L00051
	GOTO?L	_korak_shrani1
	LABEL?L	L00051	
	PAUSE?C	001F4h
	GOTO?L	_korak_shrani

	LABEL?L	_korak_shrani1	
	WRITE?CB	002h, _K1
	WRITE?CB	007h, _K2
	PAUSE?C	064h
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	053h
	LCDOUT?C	048h
	LCDOUT?C	052h
	LCDOUT?C	041h
	LCDOUT?C	04Eh
	LCDOUT?C	049h
	LCDOUT?C	04Ch
	LCDOUT?C	021h
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	04Bh
	LCDOUT?C	031h
	LCDOUT?C	020h
	LCDOUT?C	069h
	LCDOUT?C	06Eh
	LCDOUT?C	020h
	LCDOUT?C	04Bh
	LCDOUT?C	032h
	PAUSE?C	007D0h
	LCDOUT?C	0FEh
	LCDOUT?C	001h
	LCDOUT?C	050h
	LCDOUT?C	06Fh
	LCDOUT?C	06Eh
	LCDOUT?C	06Fh
	LCDOUT?C	076h
	LCDOUT?C	06Eh
	LCDOUT?C	069h
	LCDOUT?C	0FEh
	LCDOUT?C	0C0h
	LCDOUT?C	07Ah
	LCDOUT?C	061h
	LCDOUT?C	067h
	LCDOUT?C	06Fh
	LCDOUT?C	06Eh
	LCDOUT?C	020h
	LCDOUT?C	021h
	PAUSE?C	003E8h
	GOTO?L	_start
	END?	

	END
