'****************************************************************
'*  Name    : TESTER-SERVO.BAS                                  *
'*  Author  : Branko Zupan                                      *
'*  Notice  : Copyright (c) 2008 Branko Zupan                   *
'*          : All Rights Reserved                               *
'*  Date    : 13.12.2008                                        *
'*  Version : 1.0                                               *
'*  Notes   :nart:       "servotester.pdf"                     *
'*          :tiskanina:   "servotester.pcb"                     *
'****************************************************************
@ DEVICE XT_OSC,WDT_ON,PWRT_ON,PROTECT_OFF
DEFINE OSC 4  'Oscillator speed in MHz: 3(3.58) 4 8 10 12 16 20 24 25 32 33 40
INCLUDE "bs2defs.bas"
symbol GOR = PORTA.1     'tipka za pritevanje
symbol DOL = PORTA.0     'tipka za odtevanje
      CIFRA VAR WORD      'dolina impulsa
      CIFRA1 VAR BYTE     'tisoice
      CIFRA2 VAR BYTE     'stotice
      CIFRA3 VAR BYTE     'desetice
      CIFRA4 VAR BYTE     'enice
      i var byte  
      CIFRA = 1500        '1,5 mS impuls (sredina)
start:      
      CIFRA1 = CIFRA DIG 3 'izdvajamo tisoice za display
      CIFRA2 = CIFRA DIG 2' izdvajamo stotice za display 
      CIFRA3 = CIFRA DIG 1' izdvajamo desetice za display  
      CIFRA4 = CIFRA DIG 0' izdvajamo enice za display
      
gosub tipke             'pogleda e je pritisnjena kakna tipka
'impuls na izhod 
      high PORTA.2
      pauseus CIFRA
      low  PORTA.2
'izpis na display
          PORTB = CIFRA1
          high PORTB.4
          PAUSE 5
          low PORTB.4
          PORTB = CIFRA2 
          HIGH PORTB.5 
          PAUSE 5 
          LOW PORTB.5 
goto start

tipke:
      PAUSE 100
      if GOR = 0 and dol = 0 then goto levo_desno
      PAUSE 100
      if GOR = 0 then CIFRA = CIFRA + 10
      if cifra >= 2300 then cifra = 2300
      PAUSE 100
      if dol = 0 then CIFRA = CIFRA - 10
      if cifra <= 700 then cifra = 700
      PAUSE 100
return

levo_desno:
      cifra = 1000
           FOR i = 1 TO 100 ' teje od 1 do 100
'impuls na izhod 
      high PORTA.2
      pauseus CIFRA
      low  PORTA.2
'izpis na display
          PORTB = CIFRA1
          high PORTB.4
          PAUSE 5
          low PORTB.4
          PORTB = CIFRA2 
          HIGH PORTB.5 
          PAUSE 5 
          LOW PORTB.5 
if GOR = 0 or dol = 0 then goto start 'vraa se na start
           NEXT i ' nazaj na pritevanje 
      cifra = 2000
           FOR i = 1 TO 100 ' teje od 1 do 100
'impuls na izhod 
      high PORTA.2
      pauseus CIFRA
      low  PORTA.2
'izpis na display
          PORTB = CIFRA1
          high PORTB.4
          PAUSE 5
          low PORTB.4
          PORTB = CIFRA2 
          HIGH PORTB.5 
          PAUSE 5 
          LOW PORTB.5 
if GOR = 0 or dol = 0 then goto start 'vraa se na start
           NEXT i ' nazaj na pritevanje 
end
